const char *settimana[] =
    { "domenica", "luned", "marted", "mercoled", "gioved", "venerd",
    "sabato"
};

static int is_localmap(const char *a)
{
    return strncmp(a, "mappe/NZ_NZ", sizeof("mappe/NZ_NZ") - 1);
}

static FILE *apri(char *filebase, const char *fn)
{
    char filename[strlen(filebase) + strlen(fn) + 1];

    sprintf(filename, "%s%s", filebase, fn);
    FILE *file = fopen(filename, "w");

    if (!file) {
	explain_error(0, "Errore nella scrittura di %s", fn);
	return 0;
    }
    return file;
}

static void genera_html_file(char *filebase)
{
    FILE *file = apri(filebase, "scelta_web.html");
    if (!file)
	return;

    fprintf(file,
	    "<HTML><head><title>Extra - Il giornale in edicola</title></head>\
<frameset rows=\"105,35,*,0\" frameborder=\"NO\" border=\"0\" framespacing=\"0\" onLoad=\"window.frames['frametop'].document.form1.selSezione[0].selected=true\">\
<frame name=\"header\" scrolling=\"NO\" noresize src=\"../header.jsp\" marginwidth=\"5\" marginheight=\"10\" frameborder=\"NO\">\
<frame name=\"frametop\" scrolling=\"NO\" noresize src=\"top.html\" frameborder=\"NO\" marginwidth=\"5\" marginheight=\"0\">\
<frameset cols=\"560,*\" frameborder=\"NO\" border=\"0\" framespacing=\"0\">");

// se ci sono edizioni locali da prelevare, vengono prelevate per prime...

    char *selezione = mappe_url_slist->data;
    struct curl_slist *slist = mappe_url_slist->next;

    if (is_localmap(mappe_url_slist->data))
	for (; slist; slist = slist->next)
	    if (!is_localmap(slist->data)) {
		selezione = slist->data;
		break;
	    }

    fprintf(file,
	    "<frame name=\"downleft\" scrolling=\"AUTO\" src=\"%s\" marginwidth=\"5\" marginheight=\"5\">",
	    selezione);
    fprintf(file,
	    "<frame name=\"downright\" scrolling=\"AUTO\" src=\"../Static_Pages/White_Page1.html\" marginwidth=\"5\" marginheight=\"5\" onLoad=\"window.focus()\">\
</frameset><frame name=\"memory\" noresize src=\"../Edizione_Giornaliera/memory.html\"></frameset>\
<noframes><body bgcolor=\"#FFFFFF\" text=\"#000000\"></body></noframes></html>");

    fclose(file);
}

static void genera_html_file2(char *filebase)
{
    FILE *file = apri(filebase, "top.html");
    if (!file)
	return;

    fprintf(file,
	    "<html><head><title>Extra - Il giornale in edicola</title><link rel=\"stylesheet\" href=\"../../html/css/repubblica/top.css\" type=\"text/css\"></head>\
<script src=\"Scorri_pagine.js\" language=javascript> </script><body bgcolor=\"#FFFFFF\" text=\"#000000\" onLoad=\"loadTop()\"><script>var finestra = null;");

    fprintf(file, "function aggiornaCombo(edizione,pag) {\
	edizione = replaceValues(edizione);\
	posizione = pag;\
	var nazionale = parent.frames['frametop'].document.form1.nazionale.value;\
	if (edizione != nazionale){\
		var stringa = \"numPagine\"+edizione;\
		numPagine= eval(stringa);\
		var stringa2 = \"pagine\"+edizione;\
		pagine= eval(stringa2);\
		var stringa3 = \"indice\"+edizione;\
		indiceLocali= eval(stringa3);\
	}else {\
		temp = urlSez[parent.frames['frametop'].document.form1.selSezione.selectedIndex];\
		pagine=pagAux;\
		for(w=0;w<pagine.length;w++)\
		{\
			if(pagine[w]==temp)\
			{\
				posizione = w;\
			}\
		}\
	}\
	for(var j = parent.frames['frametop'].document.form1.selPagine.options.length;j > 0; j--)");
    fprintf(file,
	    "{	parent.frames['frametop'].document.form1.selPagine.options[j]=null;\
	}\
	parent.frames['frametop'].document.form1.selPagine.options[0]=null;\
	if (edizione == nazionale){\
		numPagine=numPagineNazionale;\
		populate(parent.frames['frametop'].document.form1, \"NZ\");\
	} else {\
		populate(parent.frames['frametop'].document.form1, \"LC\");\
	}\
	if (edizione != nazionale) {\
		for(var j = 0;j < parent.frames['frametop'].document.form1.selSezione.options.length; j++)\
		{\
			 scelta = replaceValues(parent.frames['frametop'].document.form1.selSezione.options[j].text);\
			 if (scelta == edizione)\
			 	 parent.frames['frametop'].document.form1.selSezione[j].selected=true;\
		}\
	} else {\
		parent.frames['frametop'].document.form1.selSezione[getSezIndex(pagineSezione[2*pag-2])].selected=true;\
	}\
}</script>");

    fprintf(file,
	    "<table width=\"100%%\" height=\"30\" border=\"0\" cellspacing=\"0\" cellpadding=\"2\" bgcolor=\"#CCCC99\">\
<tr><form name=\"form1\" method=\"post\" action=\"\"><!--td bgcolor=\"#FFFFFF\"><img src=\"Static_Pages/spacer.gif\" width=\"0\" height=\"30\"></td-->\
<td width=\"4\">&nbsp;</td><td width=25%%>");

    time_t time = decomponi_stringa_edizione2(edizione_in_download);

    struct tm lt = *(localtime(&time));

    fprintf(file,
	    "<input type=\"hidden\" name=\"pathTemp\" value=\"%.2d_%s_%d\">",
	    lt.tm_mday, mesi[lt.tm_mon], lt.tm_year + 1900);

    fprintf(file, "<input type=\"hidden\" name=\"position\" value=\"1\">\
<input type=\"hidden\" name=\"giornale\" value=\"repubblica\">\
<input type=\"hidden\" name=\"nazionale\" value=\"Nazionale\">\
<select name=\"selSezione\" onchange=\"choose()\">\
<option value = \"NZ\" selected>Scegli sezione</option>\
<option value = \"NZ\">Prima Pagina</option>\
<option value = \"NZ\">Esteri</option>\
<option value = \"NZ\">Pubblicit&agrave;</option>\
<option value = \"NZ\">Interni</option>\
<option value = \"NZ\">Cronaca</option>\
<option value = \"NZ\">Commenti</option>\
<option value = \"NZ\">Economia</option>\
<option value = \"NZ\">Cultura</option>\
<option value = \"NZ\">Spettacoli</option>\
<option value = \"NZ\">Sport</option>\
<option value = \"NZ\">Tempo</option>");

    struct curl_slist *slist;

    for (slist = config.ediz_local_selection; slist; slist = slist->next) {
	fprintf(file, "<option value = \"LC\">%s</option>", slist->data);
    }

    fprintf(file, "</select>&nbsp;&nbsp;\
</td><!--td width=\"40\"><img src=\"Static_Pages/spacer.gif\" width=\"40\" height=\"2\"></td-->\
<td width=25%%><select name=\"selPagine\" onchange=\"goToPage()\">\
<option selected>Scegli pagina</option>");

    fprintf(file, "<option>Pagina 1</option>");

    int k;

    for (k = 2; k < numero_pagine[NAZIONALE] - 1 - 2; k += 2)
	fprintf(file, "<option>Pagina %d -  %d </option>", k, k + 1);

    fprintf(file, "<option>Pagina %d </option></select>&nbsp;&nbsp;</td>",
	    numero_pagine[NAZIONALE] - 2);

    fprintf(file,
	    "<!--td width=\"40\"><img src=\"Static_Pages/spacer.gif\" width=\"20\" height=\"2\"></td-->\
<td class=\"sfoglia\" width=20%%><a href=\"\" onclick=\"PaginaIndietro();return false\">\
<img src=\"../Static_Pages/arrow_bck.gif\" border=0></a>&nbsp;&nbsp;<b>Sfoglia il giornale</b>&nbsp;&nbsp;\
<a href=\"\" onclick=\"PaginaAvanti();return false\"><img src=\"../Static_Pages/arrow_fwd.gif\" border=0></a>\
</td><td><select name=\"selArchivio\" onchange=\"Archivio()\"><option selected>Scegli il giorno</option>");

    for (k = 0; k < 8; time -= 86400, k++) {
	lt = *(localtime(&time));
	fprintf(file, "<option value=\"%d %s %d\">%d/%d/%d %s</option>\n",
		lt.tm_mday, mesi[lt.tm_mon], lt.tm_year + 1900, lt.tm_mday,
		lt.tm_mon + 1, lt.tm_year + 1900, settimana[lt.tm_wday]);
    }

    fprintf(file,
	    "</select>&nbsp;&nbsp;</td><td width=\"4\">&nbsp;</td></form></tr></table></body></html>");
    fclose(file);
}
